

class RequestOption {

  static const METHOD_GET = 'GET';
  static const METHOD_POST = 'POST';
  static const METHOD_PUT = 'PUT';
  static const METHOD_DELETE = 'DELETE';
  static const METHOD_PATCH = 'PATCH';
  static const METHOD_HEAD = 'HEAD';


  RequestOption({
    this.url,
    this.method = METHOD_GET,
    this.meta,
    this.headers,
    this.params,
    this.data,
  }) {
    if (this.headers == null){
      this.headers = {};
    }
    if (this.data == null){
      this.data = {};
    }
    if (this.meta == null){
      this.meta = {};
    }
    castParams();
  }

  String url;
  String method;
  Map<String, Object> headers;
  Map<String, Object> data;
  Map<String, dynamic /*String|Iterable<String>|int*/> params;
  Map<String, Object> meta;

  void castParams() {
    if (this.params == null){
      this.params = {};
    }

    this.params.forEach((k, v) {
      if (v is int) {
        this.params[k] = v.toString();
      }
    });
  }
}